#include <stdio.h>

// In diesem Beispiel wollen wir existierende Funktionen zur Verarbeitung von Zeichenketten nutzen.
// die Datei string.h enthält weitere Deklarationen zur Verarbeitung von Zeichenketten (strcmp)
#include <string.h>

// Funktionsdeklaration (oft Prototyp genannt), <Rückgabewert> <Name>(<Paramaterliste>)
// Der Compiler prüft bei Aufrufen ob die korrekten Typen übergeben wurden.
// Dafür muss die Deklaration an der Stelle bekannt sein! Deswegen werden die Header-Dateien eingebunden.

// void bedeutet kein Rückgabewert, bzw. Parameter.
void print(void);

// die Funktion "print_perimeter" gibt den Umfang eines Quadrats mit der Seitenlänge "width" aus
void print_perimeter(int width);

// die Funktion "get_circumference" gibt den Umfang zurück.
int get_circumference(int radius);


/** Funktionsdefinitionen == Implementierung der Funktion **/

void print(){
  printf("Funktion print wird aufgerufen\n");
}

void print_perimeter(int width){
  int perimeter = width * 4;
  printf("Der Umfang des Quadrates mit der Seitenlänge %d ist: %d\n", width, perimeter);
}

int get_circumference(int radius){
  // wir geben den angenaherten wert für den umfang zurück:
  return 2 * 3 * radius;
}

/** Benutzt werden die Funktionen dann so: **/

int main(int argumentCount, char ** argumente){

   // für alle Eingabeparameter, ausser dem Programmnamen
   for(int i=1; i < argumentCount ; i++){

     // mit strcmp können wir zwei Zeichenketten vergleichen. Der Rückgabewert 0 bedeutet sie sind gleich.

     if ( strcmp( argumente[i], "print") == 0 ){
       // wir rufen die Funktion "print" auf, in den Klammern stehen die Parameter (hier leer);
       print();
       continue;
     }

     if ( strcmp( argumente[i], "perimeter") == 0 ){
       // wir wollen den Umfang des Quadrates mit der Seitenlänge i ausgeben
       print_perimeter(i);
       continue;
     }

     if ( strcmp( argumente[i], "circumference") == 0 ){
       int circumference = get_circumference(i);
       printf("Der Umfang des Kreises mit Radius %d ist ungefähr %d\n", i, circumference);
       continue;
     }

     //ungültiger parameter:
     printf("Ungueltiger Parameter: %s\n", argumente[i]);

     // die Schleife läuft aber trotzdem weiter...
   }

   return 0;
}

